Index: /trunk/Poubelle/archTOI.old/Makefile
===================================================================
--- /trunk/Poubelle/archTOI.old/Makefile	(revision 437)
+++ /trunk/Poubelle/archTOI.old/Makefile	(revision 437)
@@ -0,0 +1,87 @@
+ifeq ($(HOSTTYPE), alpha)
+  CXX  = cxx
+endif
+ifndef (CFITSIODIR)
+  CFITSIODIR = ../cfitsio
+endif
+CPPFLAGS    =-O -g -I$(CFITSIODIR)
+
+LDLIBS=-L$(CFITSIODIR)/$(HOSTTYPE) -lcfitsio
+
+default: archtoi
+
+clean:
+	rm -f archtoi *.o archdump
+
+
+archtoi: archtoimain.o archtoi.o archeopsfile.o decompress.o toiiter.o toisvr.o archeops.o \
+         ssthandler.o toiinterpolator.o gpsparser.o asigps.o \
+         auxinterpgps.o tsid.o archparam.o dyffttools.o fft_mayer.o \
+         formepulse.o pisteetoile.o sstetoile.o transfelec.o \
+	 gyrohandler.o aa_hadec.o templocator.o plgalcross.o \
+	 arcunit.o
+	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@ -lm 
+archdump: archtoidump.o archeopsfile.o decompress.o archeops.o ssthandler.o
+	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@ -lm
+
+aa_hadec.o: aa_hadec.c aa_hadec.h
+archeops.o: archeops.c archeops_28.c archeops.h archeops_28.h \
+ arcunit.h
+archeops_24.o: archeops_24.c archeops.h archeops_28.h
+archeops_25.o: archeops_25.c archeops.h archeops_28.h
+archeops_26.o: archeops_26.c archeops.h archeops_28.h
+archeops_27.o: archeops_27.c archeops.h archeops_28.h
+archeops_28.o: archeops_28.c archeops.h archeops_28.h arcunit.h
+arcunit.o: arcunit.c manip.h archeops.h archeops_28.h arcunit.h
+compress.o: compress.c manip.h compress.h
+decompress.o: decompress.c archeops.h archeops_28.h compress.h
+opendir.o: opendir.c dirent.h
+archeopsfile.o: archeopsfile.cc archeopsfile.h archeops.h \
+ archeops_28.h ssthandler.h sstetoile.h pisteetoile.h transfelec.h \
+ formepulse.h gpsparser.h gyrohandler.h compress.h arcunit.h
+archparam.o: archparam.cc archparam.h
+archtoi.o: archtoi.cc archeopsfile.h archeops.h archeops_28.h \
+ ssthandler.h sstetoile.h pisteetoile.h transfelec.h formepulse.h \
+ gpsparser.h toisvr.h toiiter.h auxgps.h tsid.h archtoi.h \
+ ../cfitsio/fitsio.h ../cfitsio/longnam.h archparam.h archvers.h
+archtoidump.o: archtoidump.cc archeopsfile.h archeops.h archeops_28.h \
+ ssthandler.h sstetoile.h pisteetoile.h transfelec.h formepulse.h \
+ gpsparser.h archtoi.h toisvr.h toiiter.h auxgps.h tsid.h \
+ ../cfitsio/fitsio.h ../cfitsio/longnam.h
+archtoimain.o: archtoimain.cc archeopsfile.h archeops.h archeops_28.h \
+ ssthandler.h sstetoile.h pisteetoile.h transfelec.h formepulse.h \
+ gpsparser.h archtoi.h toisvr.h toiiter.h auxgps.h tsid.h \
+ ../cfitsio/fitsio.h ../cfitsio/longnam.h
+asigps.o: asigps.cc asigps.h auxinterpgps.h auxgps.h
+auxinterpgps.o: auxinterpgps.cc auxinterpgps.h auxgps.h \
+ ../cfitsio/fitsio.h ../cfitsio/longnam.h archvers.h
+dyffttools.o: dyffttools.cc dyffttools.h
+fft_mayer.o: fft_mayer.cc mayer_fft.h trigtbl.h
+formepulse.o: formepulse.cc mayer_fft.h dyffttools.h transfelec.h \
+ formepulse.h ssthardware.h
+gpsparser.o: gpsparser.cc gpsparser.h archeops.h archeops_28.h
+gyrohandler.o: gyrohandler.cc gyrohandler.h archeops.h archeops_28.h
+pisteetoile.o: pisteetoile.cc /usr/include/math.h \
+ /usr/local/include/g++/iostream.h archparam.h pisteetoile.h \
+ sstetoile.h transfelec.h formepulse.h
+plgalcross.o: plgalcross.cc plgalcross.h
+sstetoile.o: sstetoile.cc sstetoile.h
+ssthandler.o: ssthandler.cc ssthandler.h archeops.h archeops_28.h \
+ sstetoile.h pisteetoile.h transfelec.h formepulse.h
+templocator.o: templocator.cc templocator.h aa_hadec.h \
+ ../cfitsio/fitsio.h ../cfitsio/longnam.h plgalcross.h
+test.o: test.cc archeopsfile.h archeops.h archeops_28.h ssthandler.h \
+ sstetoile.h pisteetoile.h transfelec.h formepulse.h gpsparser.h \
+ archtoi.h toisvr.h toiiter.h auxgps.h tsid.h ../cfitsio/fitsio.h \
+ ../cfitsio/longnam.h
+toiinterpolator.o: toiinterpolator.cc toiinterpolator.h
+toiiter.o: toiiter.cc archeops.h archeops_28.h arcunit.h toiiter.h \
+ archeopsfile.h ssthandler.h sstetoile.h pisteetoile.h transfelec.h \
+ formepulse.h gpsparser.h auxgps.h tsid.h toiinterpolator.h \
+ archparam.h templocator.h
+toisvr.o: toisvr.cc toisvr.h toiiter.h archeopsfile.h archeops.h \
+ archeops_28.h ssthandler.h sstetoile.h pisteetoile.h transfelec.h \
+ formepulse.h gpsparser.h auxgps.h tsid.h archparam.h asigps.h \
+ auxinterpgps.h
+transfelec.o: transfelec.cc transfelec.h
+tsid.o: tsid.cc tsid.h
Index: /trunk/Poubelle/archTOI.old/Makefile_nodep
===================================================================
--- /trunk/Poubelle/archTOI.old/Makefile_nodep	(revision 436)
+++ /trunk/Poubelle/archTOI.old/Makefile_nodep	(revision 437)
@@ -19,5 +19,6 @@
          auxinterpgps.o tsid.o archparam.o dyffttools.o fft_mayer.o \
          formepulse.o pisteetoile.o sstetoile.o transfelec.o \
-	 gyrohandler.o aa_hadec.o templocator.o plgalcross.o
+	 gyrohandler.o aa_hadec.o templocator.o plgalcross.o \
+	 arcunit.o
 	$(LINK.cc) $^ $(LOADLIBES) $(LDLIBS) -o $@ -lm 
 archdump: archtoidump.o archeopsfile.o decompress.o archeops.o ssthandler.o