Index: trunk/SophyaPI/PI/pi3ddrw.cc
===================================================================
--- trunk/SophyaPI/PI/pi3ddrw.cc	(revision 425)
+++ trunk/SophyaPI/PI/pi3ddrw.cc	(revision 440)
@@ -125,5 +125,5 @@
 {
   if (axesFlags == kAxesNone) return;
-#if defined(__DECCXX) || defined(__KCC__)
+#if defined(CC_HAS_RTTI_SUPPORT)
   PIGraphic3D* g3 = dynamic_cast<PIGraphic3D*>(g);
 #else
@@ -318,5 +318,5 @@
   list<int>::iterator it;
   for(it = m3DrIl.begin(); it != m3DrIl.end(); it++)   
-#if defined(__DECCXX) || defined(__KCC__)
+#if defined(CC_HAS_RTTI_SUPPORT)
     (dynamic_cast<PIDrawer3D*>(GetDrawerId(*it)))->Set3DView_Obs(xo, yo, zo, teta, phi, psi, dax, day, co, dco);
 #else
@@ -333,5 +333,5 @@
   list<int>::iterator it;
   for(it = m3DrIl.begin(); it != m3DrIl.end(); it++)   
-#if defined(__DECCXX) || defined(__KCC__)
+#if defined(CC_HAS_RTTI_SUPPORT)
     (dynamic_cast<PIDrawer3D*>(GetDrawerId(*it)))->Set3DView(xc, yc, zc, xo, yo, zo, dax, day, dco, psi);
 #else
@@ -354,5 +354,5 @@
   list<int>::iterator it = m3DrIl.begin();
   if (it == m3DrIl.end())  return;
-#if defined(__DECCXX) || defined(__KCC__)
+#if defined(CC_HAS_RTTI_SUPPORT)
   PIDrawer3D* dr3 = dynamic_cast<PIDrawer3D*>(GetDrawerId(*it));
 #else
@@ -380,5 +380,5 @@
   list<int>::iterator it;
 
-#if defined(__DECCXX) || defined(__KCC__)
+#if defined(CC_HAS_RTTI_SUPPORT)
   if (vo)   for(it = m3DrIl.begin(); it != m3DrIl.end(); it++)   
     (dynamic_cast<PIDrawer3D*>(GetDrawerId(*it)))->Set3DView_Obs(xo, yo, zo, teta, phi, psi, dax, day, co, dco);
Index: trunk/SophyaPI/PI/pibwdggen.h
===================================================================
--- trunk/SophyaPI/PI/pibwdggen.h	(revision 425)
+++ trunk/SophyaPI/PI/pibwdggen.h	(revision 440)
@@ -20,7 +20,4 @@
 // Mettre dans cet ordre, sinon g++ a des problemes   
 #include <vector>   
-#if defined(__KCC__)
-#include <vector.h>
-#endif
 
 
Index: trunk/SophyaPI/PI/picmapgen.cc
===================================================================
--- trunk/SophyaPI/PI/picmapgen.cc	(revision 425)
+++ trunk/SophyaPI/PI/picmapgen.cc	(revision 440)
@@ -2,8 +2,4 @@
 #include <list>
 #include <algorithm>
-#if defined(__KCC__)
-#include <list.h>
-#include <algorithm.h>
-#endif
 #include "pisysdep.h"
 #include PICMAPNTV_H
Index: trunk/SophyaPI/PI/picmapgen.h
===================================================================
--- trunk/SophyaPI/PI/picmapgen.h	(revision 425)
+++ trunk/SophyaPI/PI/picmapgen.h	(revision 440)
@@ -5,8 +5,4 @@
 #include <string>
 #include <string.h>
-#if defined(__KCC__)
-using std::string ;
-#endif
-
 
  
Index: trunk/SophyaPI/PI/picontainergen.cc
===================================================================
--- trunk/SophyaPI/PI/picontainergen.cc	(revision 425)
+++ trunk/SophyaPI/PI/picontainergen.cc	(revision 440)
@@ -242,5 +242,5 @@
 {
 mNCh = 0;
-mACSup = true;   // Suppression automatique des widgets fils au delete
+mACSup = false;   // Pas de Suppression automatique des widgets fils au delete
 mPaSup = false;
 mChilds = new (PIWdg* [NCHALGRP]);
Index: trunk/SophyaPI/PI/pigfname.h
===================================================================
--- trunk/SophyaPI/PI/pigfname.h	(revision 425)
+++ trunk/SophyaPI/PI/pigfname.h	(revision 440)
@@ -2,8 +2,6 @@
 #define PIGFNAME_H_SEEN
 
+#include "machdefs.h"
 #include <string>
-#if defined(__KCC__)
-using std::string ;
-#endif
 
 string PIGetFileName(string = "");
Index: trunk/SophyaPI/PI/pipixmapgen.h
===================================================================
--- trunk/SophyaPI/PI/pipixmapgen.h	(revision 425)
+++ trunk/SophyaPI/PI/pipixmapgen.h	(revision 440)
@@ -10,7 +10,4 @@
 
 #include <list>
-#if defined(__KCC__)
-#include <list.h>
-#endif
 
 class PIPixmapGen : public PIBaseWdg
Index: trunk/SophyaPI/PI/pisurfdr.cc
===================================================================
--- trunk/SophyaPI/PI/pisurfdr.cc	(revision 425)
+++ trunk/SophyaPI/PI/pisurfdr.cc	(revision 440)
@@ -90,5 +90,5 @@
 {
   if (axesFlags == kAxesNone) return;
-#if defined(__DECCXX) || defined(__KCC__)
+#if defined(CC_HAS_RTTI_SUPPORT)
   PIGraphic3D* g3 = dynamic_cast<PIGraphic3D*>(g);
 #else
@@ -107,5 +107,5 @@
   if (mArr == NULL)  return;
 
-#if defined(__DECCXX) || defined(__KCC__)
+#if defined(CC_HAS_RTTI_SUPPORT)
   PIGraphic3D* g3 = dynamic_cast<PIGraphic3D*>(g);
 #else
Index: trunk/SophyaPI/PI/pisysdep.h
===================================================================
--- trunk/SophyaPI/PI/pisysdep.h	(revision 425)
+++ trunk/SophyaPI/PI/pisysdep.h	(revision 440)
@@ -1,4 +1,6 @@
 #ifndef PISYSDEP_SEEN
 #define PISYSDEP_SEEN
+
+#include "machdefs.h"
 
 #ifdef __MWERKS__         // Macintosh
Index: trunk/SophyaPI/PI/piwdggen.h
===================================================================
--- trunk/SophyaPI/PI/piwdggen.h	(revision 425)
+++ trunk/SophyaPI/PI/piwdggen.h	(revision 440)
@@ -7,12 +7,9 @@
 #define PIWDG_H_SEEN
 
+#include "machdefs.h"
 #include "pimsghandler.h"
 
 #include <string>
 #include <list>
-#if defined(__KCC__)
-using std::string ;
-#include <list.h>
-#endif
 
 
Index: trunk/SophyaPI/PI/psfile.h
===================================================================
--- trunk/SophyaPI/PI/psfile.h	(revision 425)
+++ trunk/SophyaPI/PI/psfile.h	(revision 440)
@@ -31,7 +31,4 @@
 
 #include <list>
-#if defined(__KCC__)
-#include <list.h>
-#endif
 
 enum PIPaperSize { PI_A4 = 1, PI_A3 = 2, PI_A5 = 3, PI_NotDefPaperSize = 0};
Index: trunk/SophyaPI/PIext/dlftypes.h
===================================================================
--- trunk/SophyaPI/PIext/dlftypes.h	(revision 425)
+++ trunk/SophyaPI/PIext/dlftypes.h	(revision 440)
@@ -7,10 +7,7 @@
 #define DLFTYPES_H_SEEN
 
+#include "machdefs.h"
 #include <string>
 #include <vector>
-#if defined(__KCC__)
-using std::string ;
-#include <vector.h>
-#endif
 
 // ------------ Fonctions pour trace de fonctions --------------
Index: trunk/SophyaPI/PIext/nobjmgr.cc
===================================================================
--- trunk/SophyaPI/PIext/nobjmgr.cc	(revision 425)
+++ trunk/SophyaPI/PIext/nobjmgr.cc	(revision 440)
@@ -8,9 +8,4 @@
 #include <list>
 #include <map>
-#if defined(__KCC__)
-using std::string ;
-#include <list.h>
-#include <map.h>
-#endif
 
 #include "strutil.h"
Index: trunk/SophyaPI/PIext/nobjmgr.h
===================================================================
--- trunk/SophyaPI/PIext/nobjmgr.h	(revision 425)
+++ trunk/SophyaPI/PIext/nobjmgr.h	(revision 440)
@@ -13,8 +13,4 @@
 #include <string>
 #include <vector>
-#if defined(__KCC__)
-using std::string ;
-#include <vector.h>
-#endif
 
 class NObjMgrAdapter;
Index: trunk/SophyaPI/PIext/piacmd.h
===================================================================
--- trunk/SophyaPI/PIext/piacmd.h	(revision 425)
+++ trunk/SophyaPI/PIext/piacmd.h	(revision 440)
@@ -14,10 +14,4 @@
 #include <map>
 #include <functional>
-#if defined(__KCC__)
-using std::string ;
-#include <vector.h>
-#include <map.h>
-#include <functional.h>
-#endif
 
 #include "dlftypes.h"
Index: trunk/SophyaPI/PIext/piafitting.h
===================================================================
--- trunk/SophyaPI/PIext/piafitting.h	(revision 425)
+++ trunk/SophyaPI/PIext/piafitting.h	(revision 440)
@@ -10,8 +10,4 @@
 #include <string>
 #include <vector>
-#if defined(__KCC__)
-using std::string ;
-#include <vector.h>
-#endif
 
 #include "anydataobj.h"
Index: trunk/SophyaPI/PIext/pigfd2.cc
===================================================================
--- trunk/SophyaPI/PIext/pigfd2.cc	(revision 425)
+++ trunk/SophyaPI/PIext/pigfd2.cc	(revision 440)
@@ -75,5 +75,5 @@
 if(mLAtt!=PI_NotDefLineAtt) SelectErrBar(true,true,true);
 
-#if defined(__DECCXX) || defined(__KCC__)
+#if defined(CC_HAS_RTTI_SUPPORT)
 PIGraphic3D* g3 = dynamic_cast<PIGraphic3D*>(g);
 #else
Index: trunk/SophyaPI/PIext/pintup3d.cc
===================================================================
--- trunk/SophyaPI/PIext/pintup3d.cc	(revision 425)
+++ trunk/SophyaPI/PIext/pintup3d.cc	(revision 440)
@@ -98,5 +98,5 @@
 if ( (xK < 0) || (yK < 0) || (zK < 0) )  return;
 
-#if defined(__DECCXX) || defined(__KCC__)
+#if defined(CC_HAS_RTTI_SUPPORT)
 PIGraphic3D* g3 = dynamic_cast<PIGraphic3D*>(g);
 #else
Index: trunk/SophyaPI/PIext/pistdimgapp.cc
===================================================================
--- trunk/SophyaPI/PIext/pistdimgapp.cc	(revision 425)
+++ trunk/SophyaPI/PIext/pistdimgapp.cc	(revision 440)
@@ -8,9 +8,4 @@
 #include <string>
 #include <vector>
-#if defined(__KCC__)
-using std::string ;
-#include <vector.h>
-#endif
-
 
 #include "strutil.h"
Index: trunk/SophyaPI/PIext/pistdimgapp.h
===================================================================
--- trunk/SophyaPI/PIext/pistdimgapp.h	(revision 425)
+++ trunk/SophyaPI/PIext/pistdimgapp.h	(revision 440)
@@ -10,9 +10,4 @@
 #include <map>
 #include <functional>
-#if defined(__KCC__)
-using std::string ;
-#include <map.h>
-#include <functional.h>
-#endif
 
 #include "pisysdep.h"
Index: trunk/SophyaPI/PIext/servnobjm.cc
===================================================================
--- trunk/SophyaPI/PIext/servnobjm.cc	(revision 425)
+++ trunk/SophyaPI/PIext/servnobjm.cc	(revision 440)
@@ -8,9 +8,4 @@
 #include <list>
 #include <map>
-#if defined(__KCC__)
-using std::string ;
-#include <list.h>
-#include <map.h>
-#endif
 
 #include "strutil.h"
Index: trunk/SophyaPI/PIext/servnobjm.h
===================================================================
--- trunk/SophyaPI/PIext/servnobjm.h	(revision 425)
+++ trunk/SophyaPI/PIext/servnobjm.h	(revision 440)
@@ -12,10 +12,4 @@
 #include <map>
 #include <functional>
-#if defined(__KCC__)
-using std::string ;
-#include <list.h>
-#include <map.h>
-#include <functional.h>
-#endif
 
 #include "pdlmgr.h"