Index: trunk/SophyaPI/PIext/basexecut.cc
===================================================================
--- trunk/SophyaPI/PIext/basexecut.cc	(revision 448)
+++ trunk/SophyaPI/PIext/basexecut.cc	(revision 449)
@@ -551,5 +551,4 @@
     return(0);
     }
-  cout<<"CMV -> Reza tu dois mettre ici (def_val) la valeur par defaut"<<endl;
   double def_val = 0.;
   if(tokens.size()>=3) def_val = atof(tokens[2].c_str());
@@ -718,4 +717,10 @@
 usage += "\n  Related commands: saveobj openppf savefits";  
 mpiac->RegisterCommand(kw, usage, this, "FileIO");
+kw = "ntfrascii";
+usage = "Fills an existing NTuple from ASCII table file";
+usage += "\n Usage: ntfrascii nt_name file_name [def_init_val]";
+usage += "\n  Related commands: ntloop fillnt ";
+mpiac->RegisterCommand(kw, usage, this, "FileIO");
+
 
 kw = "print";
@@ -918,10 +923,4 @@
 mpiac->RegisterCommand(kw, usage, this, "Expr. Plotting");
 
-kw = "ntfrascii";
-usage = "Fills an existing NTuple from ASCII table file";
-usage += "\n Usage: ntfrascii nt_name file_name [def_init_val]";
-usage += "\n  Related commands: ntloop fillnt ";
-mpiac->RegisterCommand(kw, usage, this, "Expr. Plotting");
-
 kw = "fillnt";
 usage = "Creates and Fills an NTuple(x,y,z,t) with (X=f(Object),Y=g(...),Z=h(...),T=k(...))";
Index: trunk/SophyaPI/PIext/nobjmgr.cc
===================================================================
--- trunk/SophyaPI/PIext/nobjmgr.cc	(revision 448)
+++ trunk/SophyaPI/PIext/nobjmgr.cc	(revision 449)
@@ -86,5 +86,4 @@
 static string* TmpDir;  // Repertoire pour les compilations / link dynamique
 
-static bool BeQuiet = false;  // Moins de messages ...
 
 // Pour completer le nom de l'objet avec le nom du repertoire
@@ -172,4 +171,11 @@
 }
 
+
+static bool verbeux = false;  // true -> plus de message (creation/suppression d'objets)
+void NamedObjMgr::SetVerbose(bool fg)
+{
+verbeux = fg;
+}
+
 /* --Methode-- */
 PIStdImgApp* NamedObjMgr::GetImgApp()
@@ -207,5 +213,5 @@
   (myImgApp->ObjMgrW())->AddDirectory(str.c_str(), myDirId);
   }
-cout << "NamedObjMgr::CreateDir() " << dirname << " Created " << endl;
+if (verbeux) cout << "NamedObjMgr::CreateDir() " << dirname << " Created " << endl;
 return(true);
 }
@@ -239,5 +245,5 @@
   (myImgApp->ObjMgrW())->DelDirectory((*it).second.id);
 myDirs->erase(it);
-cout << "NamedObjMgr::DeleteDir() " << dirname << " deleted " << endl;  
+if (verbeux) cout << "NamedObjMgr::DeleteDir() " << dirname << " deleted " << endl;  
 return(true);
 }
@@ -250,5 +256,5 @@
 if (it == myDirs->end()) return;
 (*it).second.lock = true;
-cout << "NamedObjMgr::LockDir() " << dirname << " Locked " << endl;
+if (verbeux) cout << "NamedObjMgr::LockDir() " << dirname << " Locked " << endl;
 return;
 }
@@ -261,5 +267,5 @@
 if (it == myDirs->end()) return;
 (*it).second.lock = true;
-cout << "NamedObjMgr::UnlockDir() " << dirname << " Unlocked " << endl;
+if (verbeux) cout << "NamedObjMgr::UnlockDir() " << dirname << " Unlocked " << endl;
 return;
 }
@@ -272,4 +278,5 @@
 if (it == myDirs->end()) return;
 (*it).second.keepold = keepold;
+if (!verbeux) return;
 cout << "NamedObjMgr::SetKeepOldDirAtt() " << dirname << "  ->  ";
 if ( keepold ) cout << " True " << endl;
@@ -292,5 +299,5 @@
   }
 *currDir = dirname;
-cout << "NamedObjMgr::SetCurrentDir() -> " << dirname << endl;
+if (verbeux) cout << "NamedObjMgr::SetCurrentDir() -> " << dirname << endl;
 return(true);
 }
@@ -413,7 +420,5 @@
 // Si c'est le repertoire /func, on nettoie
 if (nrep == "func")  {
-  BeQuiet = true;   
   CleanDir(nrep);
-  BeQuiet = false;
   }
 
@@ -459,5 +464,5 @@
 (*itr).second.nobj++;
 
-cout << "NamedObjMgr::AddObj()  Object " << nom << " ( "  
+if (verbeux) cout << "NamedObjMgr::AddObj()  Object " << nom << " ( "  
      << typeid(*obj).name() << " ) added (Total= " << myObjs->size() << ")" << endl;  
 return(true);
@@ -505,5 +510,6 @@
 itr = myDirs->find(r2);
 (*itr).second.nobj++;
-cout << "NamedObjMgr::RenameObj() - Object " << nom << " renamed to " << nomnew << endl;
+if (verbeux) 
+  cout << "NamedObjMgr::RenameObj() - Object " << nom << " renamed to " << nomnew << endl;
 return(true);
 }
@@ -534,5 +540,5 @@
 (*itr).second.nobj--;
 
-if (BeQuiet) return(true);  
+if (!verbeux) return(true);  
 if (fgd) cout << "NamedObjMgr::DelObj()  Object " << nom << " deleted (Total= " << myObjs->size() << ")" << endl;
 else  cout << "NamedObjMgr::DelObj()  Object " << nom << " removed (Total= " << myObjs->size() << ")" << endl;
@@ -686,4 +692,5 @@
 string nom;
 
+int nread = 0;
 if ( (s.NbTags() < 1) || (num >= s.NbTags()) ) {
   if (num >= 0) { 
@@ -701,4 +708,5 @@
   nom = "";
   AddObj(obj->DataObj(), nom);
+  nread++;
 }
  
@@ -717,7 +725,8 @@
     ok = false; 
   } ENDTRY;
-  if (ok)  AddObj(obj->DataObj(), nom, true);  
-}
-
+  if (ok)  { AddObj(obj->DataObj(), nom, true);  nread++; }
+}
+
+cout << "NamedObjMgr::ReadObj(...) " << nread << " Objects read " << endl;
 return;
 }
@@ -919,5 +928,5 @@
 obja = GetObjAdapter(nom);
 if (obja == NULL) {
-  cout << "NamedObjMgr::DisplayImage() Error , Pas d'objet de nom " << nom << endl; 
+  cout << "NamedObjMgr::DisplayImage() Error , No such object " << nom << endl; 
   return;
 }
@@ -928,5 +937,5 @@
 if (!arr) { 
   string ctyp = typeid(*(obja->GetDataObj())).name();
-  cout << "NamedObjMgr::DisplayImage() Error , Non supporte pour " << ctyp << endl; 
+  cout << "NamedObjMgr::DisplayImage() Error , Not supported for " << ctyp << endl; 
   return;
   }
@@ -954,5 +963,5 @@
 obja = GetObjAdapter(nom);
 if (obja == NULL) {
-  cout << "NamedObjMgr::DisplayImage() Error , Pas d'objet de nom " << nom << endl; 
+  cout << "NamedObjMgr::DisplaySurf3D() Error , No such object " << nom << endl; 
   return;
 }
@@ -963,5 +972,5 @@
 if (!arr) { 
   string ctyp = typeid(*(obja->GetDataObj())).name();
-  cout << "NamedObjMgr::DisplaySurf3D() Error , Non supporte pour " << ctyp << endl; 
+  cout << "NamedObjMgr::DisplaySurf3D() Error , Not supported " << ctyp << endl; 
   return;
   }
@@ -969,5 +978,5 @@
 if ((arr->XSize() > 250) || (arr->YSize() > 250)) {
   cout << "NamedObjMgr::DisplaySurf3D() Error , 2D-Array(" <<  arr->XSize() 
-       << "x" << arr->YSize() << ") trop grand (max=250x250)" << endl; 
+       << "x" << arr->YSize() << ") too big (max=250x250)" << endl; 
   delete arr;
   return;
@@ -998,5 +1007,5 @@
 AnyDataObj* obj=GetObj(nom);
 if (obj == NULL) {
-  cout << "NamedObjMgr::DisplayNT() Error , Pas d'objet de nom " << nom << endl; 
+  cout << "NamedObjMgr::DisplayNT() Error , No such object " << nom << endl; 
   return;
 }
@@ -1007,5 +1016,5 @@
 // if (typeid(*obj) != typeid(NTupleInterface)) { 
   string ctyp = typeid(*obj).name();
-  cout << "NamedObjMgr::DisplayNT() Error , Objet n'est pas un NTuple " << ctyp << endl; 
+  cout << "NamedObjMgr::DisplayNT() Error , Object not an NTuple " << ctyp << endl; 
   return;
   }
@@ -1061,10 +1070,10 @@
 AnyDataObj* obj=GetObj(nom);
 if(obj == NULL)
-  {cout << "NamedObjMgr::DisplayGFD() Error , Pas d'objet de nom " << nom << endl; 
+  {cout << "NamedObjMgr::DisplayGFD() Error , No such object " << nom << endl; 
    return;}
 if(!myImgApp) return; 
 if(typeid(*obj) != typeid(GeneralFitData))
   {string ctyp = typeid(*obj).name();
-   cout<<"NamedObjMgr::DisplayGFD() Error , Objet n'est pas un GeneralFitData "<<ctyp<<endl; 
+   cout<<"NamedObjMgr::DisplayGFD() Error , Object not a GeneralFitData "<<ctyp<<endl; 
    return;}
 
Index: trunk/SophyaPI/PIext/nobjmgr.h
===================================================================
--- trunk/SophyaPI/PIext/nobjmgr.h	(revision 448)
+++ trunk/SophyaPI/PIext/nobjmgr.h	(revision 449)
@@ -25,4 +25,5 @@
 
   virtual void 		SetImgApp(PIStdImgApp* app);
+  virtual void 		SetVerbose(bool fg=false);
 
 
Index: trunk/SophyaPI/PIext/piacmd.cc
===================================================================
--- trunk/SophyaPI/PIext/piacmd.cc	(revision 448)
+++ trunk/SophyaPI/PIext/piacmd.cc	(revision 449)
@@ -480,16 +480,16 @@
 
 // >>>> Substitution d'alias (1er mot)
-int als = 0;
-while (als < 2) {
-  p = s.find_first_not_of(" ");
-  s = s.substr(p);
+p = 0;
+q = s.find_first_of(" \t");
+l = s.length();
+string w1 =  (q < l) ? s.substr(p,q-p) : s.substr(p);
+it = mAliases.find(w1);
+if (it != mAliases.end())  { 
+  s =  (q < l) ? ((*it).second + s.substr(q)) : (*it).second ;
+  l = s.length();
+  p=s.find_first_not_of(" \t");
+  if (p < l) s = s.substr(p);
   p = 0;
   q = s.find_first_of(" ");
-  l = s.length();
-  string w1 =  (q < l) ? s.substr(p,q-p) : s.substr(p);
-  it = mAliases.find(w1);
-  if (it != mAliases.end())  s =  (*it).second + s.substr(q);
-  else als++;
-  als++;
   }
 
Index: trunk/SophyaPI/PIext/pistdimgapp.cc
===================================================================
--- trunk/SophyaPI/PIext/pistdimgapp.cc	(revision 448)
+++ trunk/SophyaPI/PIext/pistdimgapp.cc	(revision 449)
@@ -101,4 +101,5 @@
 m[5]->AppendCheckItem("Catch SigFPE", 10603);
 m[5]->AppendCheckItem("Catch SigSEGV", 10604);
+m[5]->AppendCheckItem("ObjMgr Verb", 10605);
 
 m[6] = new PIMenu(Menubar(),"Modules");
@@ -150,4 +151,8 @@
 mObjMgr = new NamedObjMgr;
 mCmd = new PIACmd(mObjMgr, this);
+
+// Pas trop de message de la part de NamedObjMgr
+m[5]->SetStateMsg(10605, false);
+mObjMgr->SetVerbose(false);
 
 char* varenv;
@@ -1211,4 +1216,7 @@
     CatchSignals(m[5]->GetStateMsg(10603), m[5]->GetStateMsg(10604));
     break;
+  case 10605:
+    mObjMgr->SetVerbose(m[5]->GetStateMsg(10605));
+    break;
   default:
     cerr << "PIStdImgApp::MBProcess6() BUG?? Msg= " <<  msg << endl;    
Index: trunk/SophyaPI/PIext/servnobjm.cc
===================================================================
--- trunk/SophyaPI/PIext/servnobjm.cc	(revision 448)
+++ trunk/SophyaPI/PIext/servnobjm.cc	(revision 449)
@@ -94,5 +94,5 @@
 if ((fip = fopen(fname.c_str(), "w")) == NULL)   { 
   string sn = fname; 
-  cout << "Services2NObjMgr/PlotFunc_Erreur: Pb. Ouverture " << sn << endl; 
+  cout << "Services2NObjMgr/PlotFunc_Error: fopen( " << sn << endl; 
   return; 
   }
@@ -129,5 +129,5 @@
 if ((fip = fopen(fname.c_str(), "w")) == NULL)   { 
   string sn = fname; 
-  cout << "Services2NObjMgr/PlotFunc2D_Erreur: Pb. Ouverture " << sn << endl; 
+  cout << "Services2NObjMgr/PlotFunc2D_Error:  fopen( " << sn << endl; 
   return; 
   }
@@ -287,5 +287,5 @@
 obja = mOmg->GetObjAdapter(nom);
 if (obja == NULL) {
-  cout << "Services2NObjMgr::DisplayPoints2D() Error , Pas d'objet de nom " << nom << endl; 
+  cout << "Services2NObjMgr::DisplayPoints2D() Error , No such object " << nom << endl; 
   return;
   }
@@ -330,5 +330,5 @@
 obja = mOmg->GetObjAdapter(nom);
 if (obja == NULL) {
-  cout << "Services2NObjMgr::DisplayPoints3D() Error , Pas d'objet de nom " << nom << endl; 
+  cout << "Services2NObjMgr::DisplayPoints3D() Error , No such object " << nom << endl; 
   return;
   }
@@ -372,5 +372,5 @@
 obja = mOmg->GetObjAdapter(nom);
 if (obja == NULL) {
-  cout << "Services2NObjMgr::DisplayPoints2DW() Error , Pas d'objet de nom " << nom << endl; 
+  cout << "Services2NObjMgr::DisplayPoints2DW() Error , No such object " << nom << endl; 
   return;
   }
@@ -408,5 +408,5 @@
 obja = mOmg->GetObjAdapter(nom);
 if (obja == NULL) {
-  cout << "Services2NObjMgr::ProjectH1() Error , Pas d'objet de nom " << nom << endl; 
+  cout << "Services2NObjMgr::ProjectH1() Error , No such object " << nom << endl; 
   return;
   }
@@ -457,5 +457,5 @@
 obja = mOmg->GetObjAdapter(nom);
 if (obja == NULL) {
-  cout << "Services2NObjMgr::ProjectH2() Error , Pas d'objet de nom " << nom << endl; 
+  cout << "Services2NObjMgr::ProjectH2() Error , No such object " << nom << endl; 
   return;
   }
@@ -518,5 +518,5 @@
 obja = mOmg->GetObjAdapter(nom);
 if (obja == NULL) {
-  cout << "Services2NObjMgr::ProjectHProf() Error , Pas d'objet de nom " << nom << endl; 
+  cout << "Services2NObjMgr::ProjectHProf() Error , No such object " << nom << endl; 
   return;
   }
@@ -670,5 +670,5 @@
 obja = mOmg->GetObjAdapter(nom);
 if (obja == NULL) {
-  cout << "Services2NObjMgr::ExpressionToVector() Error , Pas d'objet de nom " << nom << endl; 
+  cout << "Services2NObjMgr::ExpressionToVector() Error , No such object " << nom << endl; 
   return;
   }
@@ -723,9 +723,5 @@
 
 NTuple* nt = (NTuple*) mobj;
-cout<<"CMV -> Reza tu dois mofidier FillFromASCIIFile"<<endl;
-cout<<"CMV -> Reza pour permettre une valeur par defaut"<<endl;
-cout<<"CMV -> Reza n oublie AUSSI pas l arg par def dans servnobj.h"<<endl;
-cout<<"CMV -> Reza > nt->FillFromASCIIFile(filename,def_val);"<<endl;
-nt->FillFromASCIIFile(filename);
+nt->FillFromASCIIFile(filename, def_val);
 return;
 }
@@ -738,5 +734,5 @@
 obja = mOmg->GetObjAdapter(nom);
 if (obja == NULL) {
-  cout << "Services2NObjMgr::FillNT() Error , Pas d'objet de nom " << nom << endl; 
+  cout << "Services2NObjMgr::FillNT() Error , No such object " << nom << endl; 
   return;
   }
@@ -751,5 +747,5 @@
   nt = (NTuple*)oh;
   if (nt->NVar() > 10) {
-    cout << "Services2NObjMgr::FillNT() Warning , Max 10 var ds NTuple -> new NTuple" << endl;
+    cout << "Services2NObjMgr::FillNT() Warning , Max 10 var in NTuple -> new NTuple" << endl;
     nt = NULL;
     }
@@ -783,5 +779,5 @@
 NTupleInterface* objnt = obja->GetNTupleInterface(adel);
 if (objnt == NULL)  {
-  cout << "Services2NObjMgr::FillNTFrCFile( " << nom << "...) No NTupleInterface !" <<endl;
+  cout << "Services2NObjMgr::FillNTFrCFile( " << nom << "...) Not an NTupleInterface !" <<endl;
   return;
   }
@@ -802,5 +798,5 @@
     nt = (NTuple*)oh;
     if (nt->NVar() > 10) {
-      cout << "Services2NObjMgr::FillNTFrCFile() Warning , Max 10 var ds NTuple -> new NTuple" << endl;
+      cout << "Services2NObjMgr::FillNTFrCFile() Warning , Max 10 var in NTuple -> new NTuple" << endl;
       nt = NULL;
       }
@@ -945,5 +941,5 @@
 obja = mOmg->GetObjAdapter(nom);
 if (obja == NULL) {
-  cout << "Services2NObjMgr::FillGFD() Error , Pas d'objet de nom "<<nom<<endl;
+  cout << "Services2NObjMgr::FillGFD() Error , No such object "<<nom<<endl;
   return;
   }
@@ -1062,5 +1058,5 @@
 if ((fip = fopen(fname.c_str(), "w")) == NULL)   { 
   string sn = fname; 
-  cout << "Services2NObjMgr/LinkExprFunc_Erreur: Pb. Ouverture " << sn << endl; 
+  cout << "Services2NObjMgr/LinkExprFunc_Error: fopen( " << sn << endl; 
   return(NULL); 
   }